=== debian/changelog ===
sdformat (12.3.0+ds-2) unstable; urgency=medium

  * Move to unstable

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 11 Jan 2022 18:07:09 +0000

sdformat (12.3.0+ds-1) experimental; urgency=medium

  * Use cmake in autopkgtest
  * New upstream version 12.3.0+ds

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sun, 19 Dec 2021 19:53:25 +0000

sdformat (12.0.0+ds-1) experimental; urgency=medium

  [ Jose Luis Rivero ]
  * New upstream version 12.0.0+ds
  * Migrate debian metadata to 12 major
  * Refresh patches
  * Added patch to find ign properly
  * Update to standards 4.6.0
  * Do not need gitlab file
  * Add utils-dev in control for -dev package
  * Add CMake autopkgtest

  [ Timo Röhling ]
  * Use -DCMAKE_SKIP_RPATH=ON to make build reproducible
  * New upstream version 10.0.0+ds
  * Use local MathJax
  * Bump Standards-Version to 4.5.1
  * Bump debhelper to 13
  * Mark autopkgtest as superficial
  * Remove Multi-Arch: same from libsdformat-dev
    - Ruby module has hard-coded arch-dependent library path
  * Fix double free abort in unit tests due to faulty linkage
  * Ship examples with sdformat-doc
  * Remove obsolete libtinyxml-dev depend

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 03 Dec 2021 13:19:23 +0000
