=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DUSE_HOST_CFLAGS:BOOL=OFF \
		-DUSE_UPSTREAM_CFLAGS:BOOL=OFF \
		-DCMAKE_SKIP_RPATH:BOOL=ON

execute_after_dh_auto_build-indep:
	dh_auto_build -- doc  # Generate documentation

override_dh_auto_test-indep:

override_dh_auto_test-arch:
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/src LC_ALL=C dh_auto_test

execute_after_dh_installdocs-indep:
	dh_doxygen
